package handler

import (
	"github.com/gin-gonic/gin"
	"github.com/sirupsen/logrus"
	"youngee_b_api/consts"
	"youngee_b_api/model/http_model"
	"youngee_b_api/service"
	"youngee_b_api/util"
)

func WrapGetTalentstatusNumHandler(ctx *gin.Context) {
	handler := newGetTalentstatusNumHandler(ctx)
	baseRun(handler)
}

type GetTalentstatusNum struct {
	ctx  *gin.Context
	req  *http_model.GetTalentstatusNumRequest
	resp *http_model.CommonResponse
}

func (c GetTalentstatusNum) getContext() *gin.Context {
	return c.ctx
}

func (c GetTalentstatusNum) getResponse() interface{} {
	return c.resp
}

func (c GetTalentstatusNum) getRequest() interface{} {
	return c.req
}

func (c GetTalentstatusNum) run() {
	data := http_model.GetTalentstatusNumRequest{}
	data = *c.req
	res, err := service.Task.GetTalentstatusNum(c.ctx, data)
	if err != nil {
		logrus.Errorf("[GetTalentstatusNum] call GetTalentstatusNum err:%+v\n", err)
		util.HandlerPackErrorResp(c.resp, consts.ErrorParamCheck, "")
		logrus.Info("GetTalentstatusNum fail,req:%+v", c.req)
		return
	}
	c.resp.Message = "成功查询达人状态数量"
	c.resp.Data = res
	c.resp.Status = consts.ErrorSuccess
}

func (c GetTalentstatusNum) checkParam() error {
	return nil
}

func newGetTalentstatusNumHandler(ctx *gin.Context) *GetTalentstatusNum {
	return &GetTalentstatusNum{
		ctx:  ctx,
		req:  http_model.NewGetTalentstatusNumRequest(),
		resp: http_model.NewGetTalentStatusNumResponse(),
	}
}
